From e521df2a64f625c2838595bd89cb8bc12df0cb2c Mon Sep 17 00:00:00 2001
From: Ryan Volz <ryan.volz@gmail.com>
Date: Fri, 12 Nov 2021 14:29:54 -0500
Subject: [PATCH 07/17] CI: Add workflow to update conda CI by commenting in PR
 with "/rerender"

Signed-off-by: Ryan Volz <ryan.volz@gmail.com>
(cherry picked from commit c02b8911fd9e9b3658e2d88cf69cd9335f97f35d)
Signed-off-by: Jeff Long <willcode4@gmail.com>
---
 .conda-forge.yml                        |  3 ++
 .github/workflows/conda-rerender-ci.yml | 70 +++++++++++++++++++++++++
 .packaging/conda_recipe/README          |  2 +
 3 files changed, 75 insertions(+)
 create mode 100644 .github/workflows/conda-rerender-ci.yml

diff --git a/.conda-forge.yml b/.conda-forge.yml
index d0c808eab..b82289580 100644
--- a/.conda-forge.yml
+++ b/.conda-forge.yml
@@ -13,6 +13,9 @@
 #
 # which will automatically commit any changes.
 # ***** RUN THE ABOVE TO CHECK FOR UPDATES WHENEVER EDITS ARE MADE HERE *****
+#
+# You can also re-render from a pull request by starting a comment with
+# "/rerender", which will trigger a Github workflow to perform the above steps.
 
 # The CI will build conda packages for commits and pull requests, and it will
 # upload the packages to Anaconda Cloud on commits to the branch specified
diff --git a/.github/workflows/conda-rerender-ci.yml b/.github/workflows/conda-rerender-ci.yml
new file mode 100644
index 000000000..051309db8
--- /dev/null
+++ b/.github/workflows/conda-rerender-ci.yml
@@ -0,0 +1,70 @@
+name: 'Update conda CI via /rerender PR comment'
+on:
+  issue_comment:
+    types: [created, edited]
+jobs:
+  rerender:
+    name: Re-render conda CI
+    runs-on: ubuntu-latest
+    if: ${{ github.event.issue.pull_request && startsWith(github.event.comment.body, '/rerender') }}
+    steps:
+      - name: Get triggering PR info
+        uses: actions/github-script@v5
+        id: get-pr
+        with:
+          script: |
+            const request = {
+              owner: context.repo.owner,
+              repo: context.repo.repo,
+              pull_number: context.issue.number
+            }
+            core.info(`Getting PR #${request.pull_number} from ${request.owner}/${request.repo}`)
+            try {
+              const result = await github.rest.pulls.get(request)
+              return result.data
+            } catch (err) {
+              core.setFailed(`Request failed with error ${err}`)
+            }
+      - name: Checkout PR
+        uses: actions/checkout@v2
+        with:
+          repository: ${{ fromJSON(steps.get-pr.outputs.result).head.repo.full_name }}
+          ref: ${{ fromJSON(steps.get-pr.outputs.result).head.ref }}
+      - name: Create environment file
+        uses: DamianReeves/write-file-action@v1.0
+        with:
+          path: rerender-env.yml
+          write-mode: overwrite
+          contents: |
+            name: rerender-env
+            channels:
+              - conda-forge
+            dependencies:
+              - conda-smithy
+      - name: Install conda-smithy
+        uses: mamba-org/provision-with-micromamba@main
+        with:
+          environment-file: rerender-env.yml
+      - name: Re-render
+        shell: bash -l {0}
+        run: |
+          conda smithy rerender --feedstock_config .conda-forge.yml
+      - name: Commit and push
+        uses: EndBug/add-and-commit@v7
+        with:
+          add: ''
+          branch: ${{ fromJSON(steps.get-pr.outputs.result).head.ref }}
+          default_author: github_actions
+          message: 'CI: Re-rendered conda CI scripts via Github Action'
+          remove: '.github/workflows/automerge.yml .github/workflows/webservices.yml .circleci/config.yml'
+          signoff: true
+      - name: React to /rerender comment
+        uses: actions/github-script@v5
+        with:
+          script: |
+            github.rest.reactions.createForIssueComment({
+              owner: context.repo.owner,
+              repo: context.repo.repo,
+              comment_id: context.payload.comment.id,
+              content: 'rocket'
+            })
diff --git a/.packaging/conda_recipe/README b/.packaging/conda_recipe/README
index d132d2c18..a23c4e562 100644
--- a/.packaging/conda_recipe/README
+++ b/.packaging/conda_recipe/README
@@ -16,4 +16,6 @@ to the recipe should be accompanied by running
 
 so that the generated build scripts are updated when necessary.
 
+You can also re-render from a pull request by starting a comment with "/rerender", which will trigger a Github workflow to perform the above steps.
+
 Consult the .conda-forge.yml file for additional documentation.
-- 
2.35.1

